////////////////////////////////////////////////////////////////////////////////
// AReflection Library
// Copyright (c) 2004 by Arne Adams
// Permission to use, copy, modify, distribute and sell this software for any 
//     purpose is hereby granted without fee, provided that the above copyright 
//     notice appear in all copies and that both that copyright notice and this
//     permission notice appear in supporting documentation.
// The author makes no representations about the suitability of this software 
//     for any purpose. It is provided "as is" without express or implied 
//     warranty.
////////////////////////////////////////////////////////////////////////////////
#ifndef REFLIB_CONDITIONAL_END_H_INC_
#define REFLIB_CONDITIONAL_END_H_INC_

// taken from a posting of Paul Mensonides 
// to comp.lang.c++
// on :2003-03-11 00:13:48 PST 
// Re: Detecting a specific member function is defined 
namespace refl
{
    // attribute traversions might want to stop before the last
    // attribute is handled (for instance the attributewise comparison
    // of reflected classes may know the result after comparing the 
    // first couple of attributes).
    // To use this your Attribute Function object most have a  
    // const or non-const member function bool done(). 
    struct CheckEndCondition{};
    struct DontCheckEndCondition{};
    template<int> struct EnumToEndConditionAnswer
    {
        typedef CheckEndCondition type;
    };
    template<> struct EnumToEndConditionAnswer<0>
    {
        typedef DontCheckEndCondition type;
    };
    template<class T> class HasConditionalEnd;

    template<class C> class HasConditionalEnd<bool C::*> 
    {
        public:/* gcc 3.2 warns otherwise */
            template<bool (C::*)()const> struct goodMatch;
            template<bool (C::*)()> struct anotherGoodMatch;
            template<class T> static char check(goodMatch<&T::done>*);
            template<class T> static char check(anotherGoodMatch<&T::done>*);
            template<class T> static char (& check(...))[2];
            enum { value = sizeof(check<C>(0)) == 1 };
            typedef typename EnumToEndConditionAnswer<value>::type type;
    };
}
#endif
