////////////////////////////////////////////////////////////////////////////////
// AReflection Library
// Copyright (c) 2004 by Arne Adams
// Permission to use, copy, modify, distribute and sell this software for any 
//     purpose is hereby granted without fee, provided that the above copyright 
//     notice appear in all copies and that both that copyright notice and this 
//     permission notice appear in supporting documentation.
// The author makes no representations about the suitability of this software 
//     for any purpose. It is provided "as is" without express or implied 
//     warranty.
////////////////////////////////////////////////////////////////////////////////
#ifndef REFLIB_ISSAMECLASS_H_INC_
#define REFLIB_ISSAMECLASS_H_INC_


#include "boost/type_traits/is_same.hpp"

#include <boost/pending/ct_if.hpp>

struct IsSameClassTag{};

struct IsNotSameClassTag{};

// facilitates static overloading espcecially when explicit function template
// arguments are not properly supported by the compiler.
// I prefer tagnames over Int2Type<0> / IntToType<1> because the resulting
// code is easier to understand.
template<class Source, class Destination> struct IsSameClass
{
    enum {value = boost::is_same<Source,Destination>::value};  
    typedef typename boost::ct_if<(value != 0),
                        IsSameClassTag,
                        IsNotSameClassTag >::type
        type;
};


#endif
