////////////////////////////////////////////////////////////////////////////////
// AReflection Library
// Copyright (c) 2004 by Arne Adams
// Permission to use, copy, modify, distribute and sell this software for any 
//     purpose is hereby granted without fee, provided that the above copyright 
//     notice appear in all copies and that both that copyright notice and this 
//     permission notice appear in supporting documentation.
// The author makes no representations about the suitability of this software 
//     for any purpose. It is provided "as is" without express or implied 
//     warranty.
////////////////////////////////////////////////////////////////////////////////
#ifndef REFLIB_PASSTYPE_H_INC_
#define REFLIB_PASSTYPE_H_INC_


namespace refl
{
    // another workaround for the bug with explicit function template parameters
    // this one works even if type is a reference type (then the trick T* = NULL
    // is not allowed)
    // The corresponding "feature" of MSVC++ is described in:
    // http://support.microsoft.com/default.aspx?scid=kb;en-us;Q240871
    template<class T> struct PassType
    {
        PassType(){}                // who the hack knows why MSVC++ cannot 
        PassType(const PassType&){} // generate these when used as default 
                                    // function template argument
        typedef T type;
    };
    // workaround to be able to have one set of graph-event functions
    // in an attribute function object that can handle both: traversions
    // having a root object and traversions of static members of the 
    // root class having no root object
    template<class ReflectedClass> struct PassScope
    {
        typedef ReflectedClass type;   // incl. c-v qualification
        PassScope(type* scope):scope_(scope)
        {}
        type*  scope_;
    };
}
#endif // !

